Index: Makefile
===================================================================
--- Makefile	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ Makefile	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -28,4 +28,5 @@
 
 CSCOPE = cscope
+CHECK = tools/check.sh
 CONFIG = tools/config.py
 AUTOTOOL = tools/autotool.py
@@ -41,5 +42,5 @@
 CONFIG_HEADER = config.h
 
-.PHONY: all precheck cscope autotool config_default config distclean clean
+.PHONY: all precheck cscope autotool config_auto config_default config distclean clean check
 
 all: $(COMMON_MAKEFILE) $(COMMON_HEADER) $(CONFIG_MAKEFILE) $(CONFIG_HEADER)
@@ -55,4 +56,12 @@
 	find kernel boot uspace -regex '^.*\.[chsS]$$' | xargs $(CSCOPE) -b -k -u -f$(CSCOPE).out
 
+# Pre-integration build check
+check: $(CHECK)
+ifdef JOBS 
+	$(CHECK) -j $(JOBS)
+else
+	$(CHECK)
+endif
+
 $(COMMON_MAKEFILE): autotool
 $(COMMON_HEADER): autotool
@@ -66,5 +75,9 @@
 
 config_default: $(CONFIG_RULES)
-	$(CONFIG) $< default
+ifeq ($(HANDS_OFF),y)
+	$(CONFIG) $< hands-off $(PROFILE)
+else
+	$(CONFIG) $< default $(PROFILE)
+endif
 
 config: $(CONFIG_RULES)
Index: boot/Makefile.common
===================================================================
--- boot/Makefile.common	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ boot/Makefile.common	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -100,4 +100,6 @@
 	$(USPACE_PATH)/srv/hw/netif/dp8390/dp8390 \
 	$(USPACE_PATH)/srv/net/netif/lo/lo \
+	$(USPACE_PATH)/srv/net/nil/eth/eth \
+	$(USPACE_PATH)/srv/net/nil/nildummy/nildummy \
 	$(USPACE_PATH)/srv/net/il/arp/arp \
 	$(USPACE_PATH)/srv/net/il/ip/ip \
@@ -109,13 +111,10 @@
 	
 RD_DRVS = \
-	root
+	root \
+	rootvirt \
+	test1 \
+	test2
 
 RD_DRV_CFG = 
-
-ifneq ($(CONFIG_NETIF_NIL_BUNDLE),y)
-	RD_SRVS_NON_ESSENTIAL += \
-		$(USPACE_PATH)/srv/net/nil/eth/eth \
-		$(USPACE_PATH)/srv/net/nil/nildummy/nildummy
-endif
 
 RD_APPS_ESSENTIAL = \
@@ -141,5 +140,6 @@
 	$(USPACE_PATH)/app/stats/stats \
 	$(USPACE_PATH)/app/tasks/tasks \
-	$(USPACE_PATH)/app/top/top
+	$(USPACE_PATH)/app/top/top \
+	$(USPACE_PATH)/app/sysinfo/sysinfo
 
 ifneq ($(CONFIG_BAREBONE),y)
Index: boot/arch/amd64/Makefile.inc
===================================================================
--- boot/arch/amd64/Makefile.inc	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ boot/arch/amd64/Makefile.inc	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -37,5 +37,5 @@
 
 RD_DRVS += \
-	rootia32 \
+	rootpc \
 	pciintel \
 	isa \
Index: boot/arch/arm32/src/main.c
===================================================================
--- boot/arch/arm32/src/main.c	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ boot/arch/arm32/src/main.c	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -61,5 +61,6 @@
 	printf(" %p|%p: bootstrap page table\n", &boot_pt, &boot_pt);
 	printf(" %p|%p: boot info structure\n", &bootinfo, &bootinfo);
-	printf(" %p|%p: kernel entry point\n", PA2KA(BOOT_OFFSET), BOOT_OFFSET);
+	printf(" %p|%p: kernel entry point\n",
+	    (void *) PA2KA(BOOT_OFFSET), (void *) BOOT_OFFSET);
 	
 	size_t i;
Index: boot/arch/ia64/include/types.h
===================================================================
--- boot/arch/ia64/include/types.h	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ boot/arch/ia64/include/types.h	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -35,5 +35,5 @@
 
 typedef uint64_t size_t;
-typedef uint64_t unative_t;
+typedef uint64_t sysarg_t;
 typedef uint64_t uintptr_t;
 
@@ -61,5 +61,5 @@
 	unsigned int memmap_items;
 
-	unative_t *sapic;
+	sysarg_t *sapic;
 	unsigned long sys_freq;
 	unsigned long freq_scale;
Index: boot/arch/ia64/src/main.c
===================================================================
--- boot/arch/ia64/src/main.c	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ boot/arch/ia64/src/main.c	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -62,10 +62,12 @@
 	
 	printf(" %p|%p: boot info structure\n", &bootinfo, &bootinfo);
-	printf(" %p|%p: kernel entry point\n", KERNEL_ADDRESS, KERNEL_ADDRESS);
-	printf(" %p|%p: loader entry point\n", LOADER_ADDRESS, LOADER_ADDRESS);
+	printf(" %p|%p: kernel entry point\n",
+	    (void *) KERNEL_ADDRESS, (void *) KERNEL_ADDRESS);
+	printf(" %p|%p: loader entry point\n",
+	    (void *) LOADER_ADDRESS, (void *) LOADER_ADDRESS);
 	
 	size_t i;
 	for (i = 0; i < COMPONENTS; i++)
-		printf(" %p|%p: %s image (%u/%u bytes)\n", components[i].start,
+		printf(" %p|%p: %s image (%zu/%zu bytes)\n", components[i].start,
 		    components[i].start, components[i].name,
 		    components[i].inflated, components[i].size);
Index: boot/arch/mips32/include/arch.h
===================================================================
--- boot/arch/mips32/include/arch.h	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ boot/arch/mips32/include/arch.h	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -40,5 +40,5 @@
 
 #define MSIM_VIDEORAM_ADDRESS  0xb0000000
-#define MSIM_DORDER_ADDRESS    0xb0000004
+#define MSIM_DORDER_ADDRESS    0xb0000100
 
 #ifndef __ASM__
Index: boot/arch/mips32/src/main.c
===================================================================
--- boot/arch/mips32/src/main.c	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ boot/arch/mips32/src/main.c	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -51,14 +51,19 @@
 	
 	printf("\nMemory statistics\n");
-	printf(" %p|%p: CPU map\n", PA2KA(CPUMAP_OFFSET), CPUMAP_OFFSET);
-	printf(" %p|%p: bootstrap stack\n", PA2KA(STACK_OFFSET), STACK_OFFSET);
-	printf(" %p|%p: boot info structure\n", PA2KA(BOOTINFO_OFFSET), BOOTINFO_OFFSET);
-	printf(" %p|%p: kernel entry point\n", PA2KA(BOOT_OFFSET), BOOT_OFFSET);
-	printf(" %p|%p: bootloader entry point\n", PA2KA(LOADER_OFFSET), LOADER_OFFSET);
+	printf(" %p|%p: CPU map\n", (void *) PA2KA(CPUMAP_OFFSET),
+	    (void *) CPUMAP_OFFSET);
+	printf(" %p|%p: bootstrap stack\n", (void *) PA2KA(STACK_OFFSET),
+	    (void *) STACK_OFFSET);
+	printf(" %p|%p: boot info structure\n",
+	    (void *) PA2KA(BOOTINFO_OFFSET), (void *) BOOTINFO_OFFSET);
+	printf(" %p|%p: kernel entry point\n", (void *) PA2KA(BOOT_OFFSET),
+	    (void *) BOOT_OFFSET);
+	printf(" %p|%p: bootloader entry point\n",
+	    (void *) PA2KA(LOADER_OFFSET), (void *) LOADER_OFFSET);
 	
 	size_t i;
 	for (i = 0; i < COMPONENTS; i++)
-		printf(" %p|%p: %s image (%u/%u bytes)\n", components[i].start,
-		    KSEG2PA(components[i].start), components[i].name,
+		printf(" %p|%p: %s image (%zu/%zu bytes)\n", components[i].start,
+		    (void *) KSEG2PA(components[i].start), components[i].name,
 		    components[i].inflated, components[i].size);
 	
@@ -91,5 +96,5 @@
 		if (tail >= ((void *) PA2KA(LOADER_OFFSET))) {
 			printf("\n%s: Image too large to fit (%p >= %p), halting.\n",
-			    components[i].name, tail, PA2KA(LOADER_OFFSET));
+			    components[i].name, tail, (void *) PA2KA(LOADER_OFFSET));
 			halt();
 		}
Index: boot/arch/ppc32/include/types.h
===================================================================
--- boot/arch/ppc32/include/types.h	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ boot/arch/ppc32/include/types.h	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -35,5 +35,5 @@
 typedef uint32_t size_t;
 typedef uint32_t uintptr_t;
-typedef uint32_t unative_t;
+typedef uint32_t sysarg_t;
 typedef int32_t native_t;
 
Index: boot/arch/ppc32/src/main.c
===================================================================
--- boot/arch/ppc32/src/main.c	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ boot/arch/ppc32/src/main.c	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -68,10 +68,12 @@
 	printf(" %p|%p: real mode trampoline\n", &real_mode, real_mode_pa);
 	printf(" %p|%p: boot info structure\n", &bootinfo, bootinfo_pa);
-	printf(" %p|%p: kernel entry point\n", PA2KA(BOOT_OFFSET), BOOT_OFFSET);
-	printf(" %p|%p: loader entry point\n", LOADER_ADDRESS, loader_address_pa);
+	printf(" %p|%p: kernel entry point\n",
+	    (void *) PA2KA(BOOT_OFFSET), (void *) BOOT_OFFSET);
+	printf(" %p|%p: loader entry point\n",
+	    (void *) LOADER_ADDRESS, loader_address_pa);
 	
 	size_t i;
 	for (i = 0; i < COMPONENTS; i++)
-		printf(" %p|%p: %s image (%u/%u bytes)\n", components[i].start,
+		printf(" %p|%p: %s image (%zu/%zu bytes)\n", components[i].start,
 		    ofw_translate(components[i].start), components[i].name,
 		    components[i].inflated, components[i].size);
Index: boot/arch/sparc64/include/types.h
===================================================================
--- boot/arch/sparc64/include/types.h	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ boot/arch/sparc64/include/types.h	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -35,5 +35,5 @@
 typedef uint64_t size_t;
 typedef uint64_t uintptr_t;
-typedef uint64_t unative_t;
+typedef uint64_t sysarg_t;
 typedef int64_t native_t;
 
Index: boot/arch/sparc64/src/main.c
===================================================================
--- boot/arch/sparc64/src/main.c	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ boot/arch/sparc64/src/main.c	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -209,13 +209,15 @@
 	void *loader_address_pa = ofw_translate((void *) LOADER_ADDRESS);
 	
-	printf("\nMemory statistics (total %llu MB, starting at %p)\n",
-	    bootinfo.memmap.total >> 20, bootinfo.physmem_start);
-	printf(" %p|%p: boot info structure\n", &bootinfo, bootinfo_pa);
-	printf(" %p|%p: kernel entry point\n", KERNEL_ADDRESS, kernel_address_pa);
-	printf(" %p|%p: loader entry point\n", LOADER_ADDRESS, loader_address_pa);
+	printf("\nMemory statistics (total %" PRIu64 " MB, starting at %p)\n",
+	    bootinfo.memmap.total >> 20, (void *) bootinfo.physmem_start);
+	printf(" %p|%p: boot info structure\n", &bootinfo, (void *) bootinfo_pa);
+	printf(" %p|%p: kernel entry point\n",
+	    (void *) KERNEL_ADDRESS, (void *) kernel_address_pa);
+	printf(" %p|%p: loader entry point\n",
+	    (void *) LOADER_ADDRESS, (void *) loader_address_pa);
 	
 	size_t i;
 	for (i = 0; i < COMPONENTS; i++)
-		printf(" %p|%p: %s image (%u/%u bytes)\n", components[i].start,
+		printf(" %p|%p: %s image (%zu/%zu bytes)\n", components[i].start,
 		    ofw_translate(components[i].start), components[i].name,
 		    components[i].inflated, components[i].size);
Index: boot/genarch/include/ofw.h
===================================================================
--- boot/genarch/include/ofw.h	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ boot/genarch/include/ofw.h	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -40,5 +40,5 @@
 #define OFW_TREE_PROPERTY_MAX_VALUELEN  64
 
-typedef unative_t ofw_arg_t;
+typedef sysarg_t ofw_arg_t;
 typedef native_t ofw_ret_t;
 typedef uint32_t ofw_prop_t;
Index: boot/genarch/src/ofw.c
===================================================================
--- boot/genarch/src/ofw.c	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ boot/genarch/src/ofw.c	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -243,5 +243,5 @@
 	void *addr = ofw_claim_virt_internal(virt, len, 0);
 	if (addr != virt) {
-		printf("Error: Unable to claim virtual memory %p (size %u), halting.\n",
+		printf("Error: Unable to claim virtual memory %p (size %zu), halting.\n",
 		    virt, len);
 		halt();
@@ -254,5 +254,5 @@
 	
 	if (addr == NULL) {
-		printf("Error: Unable to claim %u bytes in virtual memory, halting.\n",
+		printf("Error: Unable to claim %zu bytes in virtual memory, halting.\n",
 		    len);
 		halt();
@@ -305,5 +305,5 @@
 	void *addr = ofw_claim_phys_internal(phys, len, 0);
 	if (addr != phys) {
-		printf("Error: Unable to claim physical memory %p (size %u), halting.\n",
+		printf("Error: Unable to claim physical memory %p (size %zu), halting.\n",
 		    phys, len);
 		halt();
@@ -315,5 +315,5 @@
 	void *addr = ofw_claim_phys_internal(NULL, len, alignment);
 	if (addr == NULL) {
-		printf("Error: Unable to claim %u bytes in physical memory, halting.\n",
+		printf("Error: Unable to claim %zu bytes in physical memory, halting.\n",
 		    len);
 		halt();
@@ -343,5 +343,5 @@
 	
 	if (ret != 0) {
-		printf("Error: Unable to map %p to %p (size %u), halting.\n",
+		printf("Error: Unable to map %p to %p (size %zu), halting.\n",
 		    virt, phys, size);
 		halt();
Index: boot/generic/include/printf.h
===================================================================
--- boot/generic/include/printf.h	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ boot/generic/include/printf.h	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -36,8 +36,20 @@
 #include <stdarg.h>
 
+#ifndef NVERIFY_PRINTF
+
+#define PRINTF_ATTRIBUTE(start, end) \
+	__attribute__((format(gnu_printf, start, end)))
+
+#else /* NVERIFY_PRINTF */
+
+#define PRINTF_ATTRIBUTE(start, end)
+
+#endif /* NVERIFY_PRINTF */
+
 #define EOF  (-1)
 
 extern int puts(const char *);
-extern int printf(const char *, ...);
+extern int printf(const char *, ...)
+    PRINTF_ATTRIBUTE(1, 2);
 extern int vprintf(const char *, va_list);
 
Index: boot/generic/include/stdint.h
===================================================================
--- boot/generic/include/stdint.h	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ boot/generic/include/stdint.h	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -33,27 +33,27 @@
 #define BOOT_STDINT_H_
 
-#define INT8_MIN  (0x80)
-#define INT8_MAX  (0x7F)
+#define INT8_MIN  INT8_C(0x80)
+#define INT8_MAX  INT8_C(0x7F)
 
-#define UINT8_MIN  (0u)
-#define UINT8_MAX  (0xFFu)
+#define UINT8_MIN  UINT8_C(0)
+#define UINT8_MAX  UINT8_C(0xFF)
 
-#define INT16_MIN  (0x8000)
-#define INT16_MAX  (0x7FFF)
+#define INT16_MIN  INT16_C(0x8000)
+#define INT16_MAX  INT16_C(0x7FFF)
 
-#define UINT16_MIN  (0u)
-#define UINT16_MAX  (0xFFFFu)
+#define UINT16_MIN  UINT16_C(0)
+#define UINT16_MAX  UINT16_C(0xFFFF)
 
-#define INT32_MIN  (0x80000000l)
-#define INT32_MAX  (0x7FFFFFFFl)
+#define INT32_MIN  INT32_C(0x80000000)
+#define INT32_MAX  INT32_C(0x7FFFFFFF)
 
-#define UINT32_MIN  (0ul)
-#define UINT32_MAX  (0xFFFFFFFFul)
+#define UINT32_MIN  UINT32_C(0)
+#define UINT32_MAX  UINT32_C(0xFFFFFFFF)
 
-#define INT64_MIN  (0x8000000000000000ll)
-#define INT64_MAX  (0x7FFFFFFFFFFFFFFFll)
+#define INT64_MIN  INT64_C(0x8000000000000000)
+#define INT64_MAX  INT64_C(0x7FFFFFFFFFFFFFFF)
 
-#define UINT64_MIN  (0ull)
-#define UINT64_MAX  (0xFFFFFFFFFFFFFFFFull)
+#define UINT64_MIN  UINT64_C(0)
+#define UINT64_MAX  UINT64_C(0xFFFFFFFFFFFFFFFF)
 
 #endif
Index: boot/generic/include/typedefs.h
===================================================================
--- boot/generic/include/typedefs.h	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ boot/generic/include/typedefs.h	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -37,5 +37,5 @@
 #include <arch/types.h>
 
-#define NULL  0
+#define NULL  ((void *) 0)
 
 #define false  0
@@ -43,5 +43,4 @@
 
 typedef uint8_t bool;
-typedef int32_t wchar_t;
 
 #endif
Index: boot/generic/src/printf_core.c
===================================================================
--- boot/generic/src/printf_core.c	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ boot/generic/src/printf_core.c	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -79,5 +79,6 @@
 	PrintfQualifierLong,
 	PrintfQualifierLongLong,
-	PrintfQualifierPointer
+	PrintfQualifierPointer,
+	PrintfQualifierSize
 } qualifier_t;
 
@@ -431,6 +432,4 @@
  *  - ""   Signed or unsigned int (default value).@n
  *  - "l"  Signed or unsigned long int.@n
- *         If conversion is "c", the character is wchar_t (wide character).@n
- *         If conversion is "s", the string is wchar_t * (wide string).@n
  *  - "ll" Signed or unsigned long long int.@n
  *
@@ -612,4 +611,9 @@
 				}
 				break;
+			case 'z':
+				qualifier = PrintfQualifierSize;
+				i = nxt;
+				uc = str_decode(fmt, &nxt, STR_NO_LIMIT);
+				break;
 			default:
 				/* Default type */
@@ -720,4 +724,8 @@
 				number = (uint64_t) (uintptr_t) va_arg(ap, void *);
 				break;
+			case PrintfQualifierSize:
+				size = sizeof(size_t);
+				number = (uint64_t) va_arg(ap, size_t);
+				break;
 			default:
 				/* Unknown qualifier */
Index: contrib/arch/hadlbppp.py
===================================================================
--- contrib/arch/hadlbppp.py	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ contrib/arch/hadlbppp.py	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -1151,5 +1151,5 @@
 					continue
 				
-				if ((token == "ipcarg_t") or (token == "unative_t")):
+				if (token == "sysarg_t"):
 					output += "\n%s%s " % (tabs(indent), token)
 					context.add(PROTOTYPE)
Index: contrib/arch/kernel/kernel.adl
===================================================================
--- contrib/arch/kernel/kernel.adl	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ contrib/arch/kernel/kernel.adl	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -5,5 +5,5 @@
 interface sys_klog {
 		/* Print using kernel facility */
-		unative_t sys_klog(int fd, const void *buf, size_t size);
+		sysarg_t sys_klog(int fd, const void *buf, size_t size);
 	protocol:
 		?sys_klog*
@@ -12,8 +12,8 @@
 interface sys_console {
 		/* Enable kernel console */
-		unative_t sys_debug_enable_console(void);
+		sysarg_t sys_debug_enable_console(void);
 		
 		/* Disable kernel console */
-		unative_t sys_debug_disable_console(void);
+		sysarg_t sys_debug_disable_console(void);
 	protocol:
 		(
@@ -25,5 +25,5 @@
 interface sys_tls {
 		/* Set thread-local storage pointer (on architectures where kernel mode is required) */
-		unative_t sys_tls_set(unative_t addr);
+		sysarg_t sys_tls_set(sysarg_t addr);
 	protocol:
 		?sys_tls_set*
@@ -32,11 +32,11 @@
 interface sys_thread {
 		/* Create new thread */
-		unative_t sys_thread_create(uspace_arg_t *uspace_uarg, char *uspace_name, size_t name_len, thread_id_t *uspace_thread_id);
+		sysarg_t sys_thread_create(uspace_arg_t *uspace_uarg, char *uspace_name, size_t name_len, thread_id_t *uspace_thread_id);
 		
 		/* Terminate current thread */
-		unative_t sys_thread_exit(int uspace_status);
+		sysarg_t sys_thread_exit(int uspace_status);
 		
 		/* Get current thread id */
-		unative_t sys_thread_get_id(thread_id_t *uspace_thread_id);
+		sysarg_t sys_thread_get_id(thread_id_t *uspace_thread_id);
 	protocol:
 		(
@@ -49,8 +49,8 @@
 interface sys_task {
 		/* Set name fo the current task */
-		unative_t sys_task_set_name(const char *uspace_name, size_t name_len);
+		sysarg_t sys_task_set_name(const char *uspace_name, size_t name_len);
 		
 		/* Get current task id */
-		unative_t sys_task_get_id(task_id_t *uspace_task_id);
+		sysarg_t sys_task_get_id(task_id_t *uspace_task_id);
 	protocol:
 		(
@@ -62,5 +62,5 @@
 interface sys_program {
 		/* Spawn a new instance of clonable loader service */
-		unative_t sys_program_spawn_loader(char *uspace_name, size_t name_len);
+		sysarg_t sys_program_spawn_loader(char *uspace_name, size_t name_len);
 	protocol:
 		?sys_program_spawn_loader*
@@ -69,8 +69,8 @@
 interface sys_futex {
 		/* Sleep in a futex wait queue */
-		unative_t sys_futex_sleep_timeout(uintptr_t uaddr, uint32_t usec, int flags);
+		sysarg_t sys_futex_sleep_timeout(uintptr_t uaddr, uint32_t usec, int flags);
 		
 		/* Wakeup one thread waiting in futex wait queue */
-		unative_t sys_futex_wakeup(uintptr_t uaddr);
+		sysarg_t sys_futex_wakeup(uintptr_t uaddr);
 	protocol:
 		(
@@ -82,5 +82,5 @@
 interface sys_smc {
 		/* Enforce self-modifying code cache coherency */
-		unative_t sys_smc_coherence(uintptr_t va, size_t size);
+		sysarg_t sys_smc_coherence(uintptr_t va, size_t size);
 	protocol:
 		?sys_smc_coherence*
@@ -89,14 +89,14 @@
 interface sys_as {
 		/* Create new address space area */
-		unative_t sys_as_area_create(uintptr_t address, size_t size, int flags);
+		sysarg_t sys_as_area_create(uintptr_t address, size_t size, int flags);
 		
 		/* Resize an address space area */
-		unative_t sys_as_area_resize(uinptr_t address, size_t size, int flags);
+		sysarg_t sys_as_area_resize(uinptr_t address, size_t size, int flags);
 		
 		/* Change flags of an address space area */
-		unative_t sys_as_area_change_flags(uintptr_t address, int flags);
+		sysarg_t sys_as_area_change_flags(uintptr_t address, int flags);
 		
 		/* Destroy an address space area */
-		unative_t sys_as_area_destroy(uintptr_t address);
+		sysarg_t sys_as_area_destroy(uintptr_t address);
 	protocol:
 		(
@@ -110,35 +110,35 @@
 interface sys_ipc {
 		/* Fast synchronous IPC call */
-		unative_t sys_ipc_call_sync_fast(unative_t phoneid, unative_t method, unative_t arg1, unative_t arg2, unative_t arg3, ipc_data_t *data);
+		sysarg_t sys_ipc_call_sync_fast(sysarg_t phoneid, sysarg_t method, sysarg_t arg1, sysarg_t arg2, sysarg_t arg3, ipc_data_t *data);
 		
 		/* Slow synchronous IPC call */
-		unative_t sys_ipc_call_sync_slow(unative_t phoneid, ipc_data_t *question, ipc_data_t *answer);
+		sysarg_t sys_ipc_call_sync_slow(sysarg_t phoneid, ipc_data_t *question, ipc_data_t *answer);
 		
 		/* Fast asynchronous IPC call */
-		unative_t sys_ipc_call_async_fast(unative_t phoneid, unative_t method, unative_t arg1, unative_t arg2, unative_t arg3, unative_t arg4);
+		sysarg_t sys_ipc_call_async_fast(sysarg_t phoneid, sysarg_t method, sysarg_t arg1, sysarg_t arg2, sysarg_t arg3, sysarg_t arg4);
 		
 		/* Slow asynchronous IPC call */
-		unative_t sys_ipc_call_async_slow(unative_t phoneid, ipc_data_t *data);
+		sysarg_t sys_ipc_call_async_slow(sysarg_t phoneid, ipc_data_t *data);
 		
 		/* Fast forward a received IPC call to another destination */
-		unative_t sys_ipc_forward_fast(unative_t callid, unative_t phoneid, unative_t method, unative_t arg1, unative_t arg2, int mode);
+		sysarg_t sys_ipc_forward_fast(sysarg_t callid, sysarg_t phoneid, sysarg_t method, sysarg_t arg1, sysarg_t arg2, int mode);
 		
 		/* Slow forward a received IPC call to another destination */
-		unative_t sys_ipc_forward_slow(unative_t callid, unative_t phoneid, ipc_data_t *data, int mode);
+		sysarg_t sys_ipc_forward_slow(sysarg_t callid, sysarg_t phoneid, ipc_data_t *data, int mode);
 		
 		/* Fast answer an IPC call */
-		unative_t sys_ipc_answer_fast(unative_t callid, unative_t retval, unative_t arg1, unative_t arg2, unative_t arg3, unative_t arg4);
+		sysarg_t sys_ipc_answer_fast(sysarg_t callid, sysarg_t retval, sysarg_t arg1, sysarg_t arg2, sysarg_t arg3, sysarg_t arg4);
 		
 		/* Slow answer an IPC call */
-		unative_t sys_ipc_answer_slow(unative_t callid, ipc_data_t *data);
+		sysarg_t sys_ipc_answer_slow(sysarg_t callid, ipc_data_t *data);
 		
 		/* Hang up a phone */
-		unative_t sys_ipc_hangup(int phoneid);
+		sysarg_t sys_ipc_hangup(int phoneid);
 		
 		/* Wait for an incoming IPC call or answer */
-		unative_t sys_ipc_wait_for_call(ipc_data_t *calldata, uint32_t usec, int flags);
+		sysarg_t sys_ipc_wait_for_call(ipc_data_t *calldata, uint32_t usec, int flags);
 		
 		/* Interrupt one thread of the current task from waiting on IPC call */
-		unative_t sys_ipc_poke(void);
+		sysarg_t sys_ipc_poke(void);
 	protocol:
 		(
@@ -159,5 +159,5 @@
 interface sys_event {
 		/* Subscribe to kernel event notifications */
-		unative_t sys_event_subscribe(unative_t evno, unative_t method);
+		sysarg_t sys_event_subscribe(sysarg_t evno, sysarg_t method);
 	protocol:
 		?sys_event_subscribe*
@@ -166,8 +166,20 @@
 interface sys_cap {
 		/* Grant capabilities to a task */
-		unative_t sys_cap_grant(sysarg64_t *uspace_taskid_arg, cap_t caps);
+#ifdef __32_BITS__
+		sysarg_t sys_cap_grant(sysarg64_t *uspace_taskid, cap_t caps);
+#endif
+		
+#ifdef __64_BITS__
+		sysarg_t sys_cap_grant(sysarg_t taskid, cap_t caps);
+#endif
 		
 		/* Revoke capabilities from a task */
-		unative_t sys_cap_revoke(sysarg64_t *uspace_taskid_arg, cap_t caps);
+#ifdef __32_BITS__
+		sysarg_t sys_cap_revoke(sysarg64_t *uspace_taskid, cap_t caps);
+#endif
+		
+#ifdef __64_BITS__
+		sysarg_t sys_cap_revoke(sysarg_t taskid, cap_t caps);
+#endif
 	protocol:
 		(
@@ -179,20 +191,20 @@
 interface sys_ddi {
 		/* Enable access I/O address space for the current task */
-		unative_t sys_enable_iospace(ddi_ioarg_t *uspace_io_arg);
+		sysarg_t sys_enable_iospace(ddi_ioarg_t *uspace_io_arg);
 		
 		/* Map physical memory to the current task's address space */
-		unative_t sys_physmem_map(unative_t phys_base, unative_t virt_base, unative_t pages, unative_t flags);
+		sysarg_t sys_physmem_map(sysarg_t phys_base, sysarg_t virt_base, sysarg_t pages, sysarg_t flags);
 		
 		/* Enable or disable preemption */
-		unative_t sys_preempt_control(int enable);
+		sysarg_t sys_preempt_control(int enable);
 		
 		/* Assign unique device number */
-		unative_t sys_device_assign_devno(void);
+		sysarg_t sys_device_assign_devno(void);
 		
 		/* Connect an IRQ handler to the current task */
-		unative_t sys_ipc_register_irq(inr_t inr, devno_t devno, unative_t method, irq_code_t *ucode);
+		sysarg_t sys_ipc_register_irq(inr_t inr, devno_t devno, sysarg_t method, irq_code_t *ucode);
 		
 		/* Disconnect an IRQ handler from the current task */
-		unative_t sys_ipc_unregister_irq(inr_t inr, devno_t devno);
+		sysarg_t sys_ipc_unregister_irq(inr_t inr, devno_t devno);
 	protocol:
 		(
@@ -208,8 +220,8 @@
 interface sys_sysinfo {
 		/* Check for sysinfo key validity */
-		unative_t sys_sysinfo_valid(unative_t ptr, unative_t len);
+		sysarg_t sys_sysinfo_valid(sysarg_t ptr, sysarg_t len);
 		
 		/* Get sysinfo key value */
-		unative_t sys_sysinfo_value(unatice_t ptr, unative_t len);
+		sysarg_t sys_sysinfo_value(unatice_t ptr, sysarg_t len);
 	protocol:
 		(
@@ -221,5 +233,11 @@
 interface sys_debug {
 		/* Connect to the kernel debugging answerbox of a given task */
-		unative_t sys_ipc_connect_kbox(sysarg64_t *uspace_taskid_arg);
+#ifdef __32_BITS__
+		sysarg_t sys_ipc_connect_kbox(sysarg64_t *uspace_taskid);
+#endif
+		
+#ifdef __64_BITS__
+		sysarg_t sys_ipc_connect_kbox(sysarg_t taskid);
+#endif
 	protocol:
 		?sys_ipc_connect_kbox*
Index: contrib/arch/uspace/srv/bd/bd.adl
===================================================================
--- contrib/arch/uspace/srv/bd/bd.adl	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ contrib/arch/uspace/srv/bd/bd.adl	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -1,14 +1,14 @@
 interface bd extends service {
 		/* Share out data buffer */
-		ipcarg_t ipc_m_share_out(in ipcarg_t as_area_base, in ipcarg_t as_area_size, in ipcarg_t flags, out ipcarg_t dst_as_area_base);
+		sysarg_t ipc_m_share_out(in sysarg_t as_area_base, in sysarg_t as_area_size, in sysarg_t flags, out sysarg_t dst_as_area_base);
 		
 		/* Get block size */
-		ipcarg_t get_block_size(out ipcarg_t block_size);
+		sysarg_t get_block_size(out sysarg_t block_size);
 		
 		/* Read blocks via shared data buffer */
-		ipcarg_t read_blocks(in ipcarg_t index_lower, in ipcarg_t index_upper, in ipcarg_t count);
+		sysarg_t read_blocks(in sysarg_t index_lower, in sysarg_t index_upper, in sysarg_t count);
 		
 		/* Write blocks via shared data buffer */
-		ipcarg_t write_blocks(in ipcarg_t index_lower, in ipcarg_t index_upper, in ipcarg_t count);
+		sysarg_t write_blocks(in sysarg_t index_lower, in sysarg_t index_upper, in sysarg_t count);
 	protocol:
 		[bd.bp]
Index: contrib/arch/uspace/srv/console/console.adl
===================================================================
--- contrib/arch/uspace/srv/console/console.adl	(revision 1bfd3d3b2991b8f2df4cff87d9723059528b9bd1)
+++ contrib/arch/uspace/srv/console/console.adl	(revision 973ef9fc2302afd44bcf569cc300f71adbc0acdf)
@@ -1,41 +1,41 @@
 interface console extends service {
 		/* Read characters from console */
-		ipcarg_t read(out_copy stream data);
+		sysarg_t read(out_copy stream data);
 		
 		/* Write characters to console */
-		ipcarg_t write(in_copy stream data);
+		sysarg_t write(in_copy stream data);
 		
 		/* Get last event from event queue */
-		ipcarg_t get_event(out ipcarg_t type, out ipcarg_t key, out ipcarg_t mods, out ipcarg_t char);
+		sysarg_t get_event(out sysarg_t type, out sysarg_t key, out sysarg_t mods, out sysarg_t char);
 		
 		/* Flush output buffer */
-		ipcarg_t sync(void);
+		sysarg_t sync(void);
 		
 		/* Clear console */
-		ipcarg_t clear(void);
+		sysarg_t clear(void);
 		
 		/* Move cursor to given position */
-		ipcarg_t goto(in ipcarg_t col, in ipcarg_t row);
+		sysarg_t goto(in sysarg_t col, in sysarg_t row);
 		
 		/* Get console dimensions (in character cells) */
-		ipcarg_t get_size(out ipcarg_t cols, in ipcarg_t rows);
+		sysarg_t get_size(out sysarg_t cols, in sysarg_t rows);
 		
 		/* Get color capabilities */
-		ipcarg_t get_color_cap(void);
+		sysarg_t get_color_cap(void);
 		
 		/* Set abstract text style */
-		ipcarg_t set_style(in ipcarg_t style);
+		sysarg_t set_style(in sysarg_t style);
 		
 		/* Set EGA-based text color */
-		ipcarg_t set_color(in ipcarg_t fb_color, in ipcarg_t bg_color, in ipcarg_t attr);
+		sysarg_t set_color(in sysarg_t fb_color, in sysarg_t bg_color, in sysarg_t attr);
 		
 		/* Set RGB-based text color */
-		ipcarg_t set_rgb_color(in ipcarg_t fb_color, in ipcarg_t bg_color);
+		sysarg_t set_rgb_color(in sysarg_t fb_color, in sysarg_t bg_color);
 		
 		/* Set cursor visibility */
-		ipcarg_t cursor_visibility(in ipcarg_t visible);
+		sysarg_t cursor_visibility(in sysarg_t visible);
 		
 		/* Switch to kernel debugging console (if available) */
-		ipcarg_t kcon_enable(void);
+		sysarg_t kcon_enable(void);
 	protocol:
 		[console.bp]
